<?php

function activetl_node_process($node, $field) {
	$field_value = field_get_items('node', $node, $field);
	$text = $field_value[0]['value'];
	$result = $text;
	$vocs = variable_get('activetl_vocs', array());
	// Replace taxonomy terms in text by links
	foreach ($vocs as $voc) {
		$terms = taxonomy_get_tree($voc);
		foreach ($terms as $term) {
			$result = activetl_text_term_process($result, $term);
		}
	}
	// Save results
  if (activetl_node_result_save($node, $field, $result)) {
    return TRUE;
  }
  else {
    return FALSE;
  }
}

function activetl_text_term_process($text, $term) {
  require_once 'simple_html_dom.php';
  $html = str_get_html($text);
  // Don't parse text from ignore tags array.
  $ignore_tags = array('a');
  foreach ($html->find('text') as $subtext) {
    // Don't parse text if it's a link already.
    if (in_array($subtext->parent->tag, $ignore_tags)) {
      continue;
    }
    if (substr_count($subtext->innertext, $term->name)) {
      $link = l($term->name, 'taxonomy/term/' . $term->tid);
      $match = "/\b$term->name\b/u";
      $subtext->innertext = preg_replace($match, $link, $subtext->innertext);
    }
  }
  $text = $html->outertext;
  $html->clear();
  unset($html);
	return $text;
}

function activetl_node_result_save($node, $field, $new_value) {
	// Keep original field value in db
	$original_field_value = field_get_items('node', $node, $field);
	$info = activetl_db_node_info_select($node, $field);
	if ($info) {
		$info['value'] = $original_field_value[0]['value'];
		$result = activetl_db_node_info_update($info, array('id'));
	}
	else {
		$info = array('nid' => $node->nid, 'field' => $field, 'value' => $original_field_value[0]['value']);
		$result = activetl_db_node_info_update($info);
	}
	if ($result) {
		$node->{$field}[$node->language][0]['value'] = $new_value;
		node_save($node);
		return TRUE;
	}
	else {
		drupal_set_message(t('Active taxonomy links process failed.'), 'error');
		return FALSE;
	}
}

function activetl_node_unprocess($node, $field) {
  $info = activetl_db_node_info_select($node, $field);
	$node->{$info['field']}[$node->language][0]['value'] = $info['value'];
	node_save($node);
	activetl_node_result_delete($node, $info['field']);
}

function activetl_node_result_delete($node, $field) {
	$info = activetl_db_node_info_select($node, $field);
	if ($info) {
		activetl_db_node_info_delete($node, $field);
	}
}